package nl.meandi.txtimeout;

import org.hamcrest.core.IsInstanceOf;
import org.jboss.arquillian.container.test.api.Deployment;
import org.jboss.arquillian.junit.Arquillian;
import org.jboss.shrinkwrap.api.Archive;
import org.jboss.shrinkwrap.api.ShrinkWrap;
import org.jboss.shrinkwrap.api.spec.WebArchive;
import org.junit.Rule;
import org.junit.Test;
import org.junit.rules.ExpectedException;
import org.junit.runner.RunWith;

import javax.ejb.EJBException;
import javax.inject.Inject;
import java.util.concurrent.TimeoutException;

@RunWith(Arquillian.class)
public class TxTimeoutTest {

    @Inject
    private TestBean testBean;

    @Rule
    public ExpectedException thrown = ExpectedException.none();

    @Deployment
    public static Archive deploy(){
        return ShrinkWrap.create(WebArchive.class, "test.war").addClass(TestBean.class);
    }

    @Test
    public void testWithoutTransactionTimeout() {
        thrown.expect(EJBException.class);
        thrown.expectCause(IsInstanceOf.instanceOf(RuntimeException.class));
        testBean.testWithoutTransactionTimeout();
    }

    @Test
    public void testWithTransactionTimeout() {
        thrown.expect(EJBException.class);
        thrown.expectCause(IsInstanceOf.instanceOf(RuntimeException.class));
        testBean.testWithTransactionTimeout();
    }
}
